<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>BE et Projet de Compilation</title>
  <style type="text/css">

      footer {
        padding-top: 10px;
        padding-bottom: 10px;
      }
      
      h1, h2, h3, h4, h5 {
        font-family: Sans-Serif;
        color: #993300;
        font-weight: normal;
      }
      
      tt, code {
        color: #993300;
      }
      
      pre {
        color: #993300;
        border-radius: 5px;
        border: 1px solid #993300;
        background: #ffff99;
        padding: 1ex;
        overflow: auto;
      }

      dt {
        color: #993300;
        font-family: Sans-Serif;
      }
      
      @media (max-width: 800px) {
        body > * {
          margin: 0%;
        }
      }
      @media (min-width: 800px) {
        body > * {
          margin: 1% 20% 1% 20%;
        }
      }
  </style>
</head>
<body>
  <h1>Compilation d'un petit langage</h1>
  
  <p>L'objectif de ce BE est d'écrire une grammaire ANTLR pour un
  petit langage appelé <em>Niklaus</em>, puis de compiler ce langage
  vers le langage d'assemblage du petit micro-processeur présenté en
  cours.</p>

  <p>On cherche donc à réaliser la chaine de transformations</p>
  <center>
    <tt>prog.niklaus --(1)--> prog.arm --(2)--> prog.mem --(3)--> [execution]</tt>
  </center>
  <p>(1) est réalisé par un lexeur et parseur mis en oeuvre avec
  ANTLR, (2) est réalisé à l'aide d'un programme <tt>assembler.py</tt>
  fourni, et (3) est l'exécution dans la machine logisim.</p>
  
  <ol>
    <li><a href="#niklaus">Le langage Niklaus</a></li>
    <li><a href="#letravail">Le travail demandé</a></li>
    <li><a href="#kit">Configuration</a></li>
    <li><a href="#conseils">Conseils de mise en oeuvre</a></li>
    <li><a href="#alt">API de programmation pour l'assembleur</a></li>
  </ol>
  
  <h2 id="niklaus">1 - Le langage Niklaus</h2>
  
  <p>Niklaus est un langage impératif de type Pascal, C ou Java, très
    simplifié, qui est défini dans le cadre de ce BE pour vous
    permettre de traiter <em>complètement</em> du problème de la
    compilation sur un exemple simple.</p>
  
  <h3 id="structure-dun-programme">Structure d'un programme</h3>

  <p>En Niklaus il n'y a ni fonctions ni procédures. Un programme
    s'écrit d'un seul tenant. Les variables (voir ci-dessous) doivent
    être déclarées avant le corps du programme.</p>

  <p>Structure générale :</p>
  
<pre>program NomDuProgramme;
var variable1, variable2;  // liste des variables utilisées par le programme
{
    // corps du programme (bloc)
}</pre>

  <p>Un bloc, délimité entre accolades, permet de regrouper plusieurs
    instructions. Comme on le voit ci-dessus, le corps du programme
    est constitué d'un bloc.</p>
  
  <p>Sur une ligne, tout ce qui suit les symboles <code>//</code> est
    ignoré (commentaire).</p>

  <h3>Variables, constantes, expressions</h3>

  <p>Niklaus ne connaît qu'un seul type de données : le type entier
    (équivalent au <code>int</code> de Java). C'est pour cette raison
    que l'on n'indique pas de type lors de la déclaration des
    variables (voir exemple ci-dessus) : une variable
    est <em>implicitement</em> de type entier.</p>

  <p>De même, les constantes (littéraux) sont de type
    entier. Littéraux et variables peuvent être combinés pour former
    des expressions en utilisant les quatre opérations mathématiques
    de base, le modulo (<code>mod</code>), c'est-à-dire le reste de la
    division, ainsi que les parenthèses. On utilise la syntaxe infixe
    et les règles de priorité/associativité usuelles.</p>

  <p>Exemple : <code>3*(4+5) - b mod 2</code></p>

  <h3>Comparaisons</h3>
  
  <p>Comme indiqué ci-avant, Niklaus ne comporte pas d'expressions
    booléennes, mais il est nécessaire de former
    des <em>comparaisons</em> entre expressions (entières) pour les
    conditions des instructions conditionnelle et boucle. Une
    comparaison s'écrit :</p>
  
  <pre><code>expression1 opérateur expression2</code></pre>

  <p>où un opérateur peut
    être <code>&lt;</code>, <code>&lt;=</code>, <code>=</code>, <code>&lt;&gt;</code>
    (différent), <code>&gt;=</code>, <code>&gt;</code>.</p>

  <p>Exemple : <code> x+2 &lt;= y-6</code></p>

  <h3>Instructions</h3>

  <p>Toutes les instructions simples se terminent par un
    point-virgule. Plusieurs instructions peuvent être regroupées
    entre accolades pour former un bloc (qui n'est lui-même pas suivi
    de point-virgule).</p>

  <p>Niklaus dispose des instructions suivantes :</p>
  <dl>
    <dt>read : lecture d'un entier tapé au clavier</dt>
    <dd>
      Demande à l'utilisateur de taper un nombre entier au clavier, et
      le range dans une variable. 
    </dd>
  </dl>
  <p>Syntaxe : <code>read <em>variable</em>;</code></p>
  <dl>
    <dt>write : affichage de la valeur d'une expression</dt>
    <dd>
      Affiche la valeur d'une expression à l'écran.</dd>
  </dl>
  <p>Syntaxe : <code>write <em>expression</em>;</code></p>
  <dl>
    <dt>Affectation</dt>
    <dd>
      Range dans une variable la valeur d'une expression.<br />
    </dd>
  </dl>
  <p>Syntaxe : <code><em>variable</em>
      := <em>expression</em>;</code></p>
  <dl>
    <dt>Boucle « while »</dt>
    <dd>
      Répète une instruction, ou un bloc d'instructions, tant qu'une
      comparaison est vérifiée.<br />
    </dd>
  </dl>
  <p>Syntaxe : <code>while(<em>comparaison</em>) <em>instruction</em></code></p>
  <dl>
    <dt>Condition</dt>
    <dd>
      Selon qu'une comparaison est vérifiée ou non, effectue une
      instruction parmi deux alternatives.<br />
    </dd>
  </dl>
  <p>Syntaxe : <code>if(<em>comparaison</em>) <em>instruction1</em>
    else <em>instruction2</em></code> (note : la
    clause <code>else</code> est obligatoire).</p>

  <h3>Exemple</h3>

  <p>Le programme ci-dessous invite l'utilisateur à saisir deux
    nombres, puis il calcule leur PGCD par l'algorithme d'Euclide, et
    enfin l'affiche :</p>

  <pre><code>program PGCD;
var a, b;
{
    read a;
    read b;
    while(a &lt;&gt; b) {
        if(a &gt; b) {
            a := a - b;
        } else {
            b := b - a;
        }
    }
    write a;
}</code></pre>

  <h2 id="letravail">2 - Travail demandé</h2>

  <ol>
    <li><p>Avec <a href="http://lab.antlr.org/">ANTLR Lab</a>.</p>
        <p><strong>Attention</strong>: il y a deux onglets (en haut à
        gauche): un pour le lexeur et un pour le parseur. Comme nous
        mettons tout ensemble, il faut vider l'onglet "Lexer".</p>
      <ol type="a">
        <li>
          <p><strong>Écrivez une grammaire ANTLR pour le langage
              Niklaus.</strong> Il vous est conseillé de partir du
              fragment fourni dans le kit et qui correspond à la
            reconnaissance des expressions.</p>
          <p>Vous pouvez modifier ce que vous voulez dans le fragment
          fourni. Mais décrivez vos choix.</p>
        </li>
        <li>
          <p>
            <strong>Vérifiez</strong> que chaque programme donne un
            arbre de syntaxe raisonnable: quelle serait votre
            définition de "raisonnable"?
          </p>
        </li>
      </ol>
    </li>
    <li>
      <p>Avec le kit fourni.</p>
      <ol type="a">
        <li>
          <p><strong>Écrivez un programme qui génère du code
              d'assemblage en
              utilisant <tt>NiklausVisitor.py</tt></strong>, de façon
              à terminer la réalisation d'un compilateur pour le
              langage Niklaus. On veut donc un code python qui
              produise <strong>un fichier <tt>arm</tt>
              (ou <tt>mem</tt> directement), et non pas un
              émulateur</strong>.  Utilisez ce que nous avons vu en
              cours!</p></li>
        
        <li><p><strong>Vérifiez que les codes d'exemples compilent
              correctement</strong> et que les programmes générés
            s'exécutent comme prévu. Ceux-ci se trouvent dans le
            répertoire <code>ProgrammesNiklaus</code>.</p>
        <li>
          <p>Faites les choses de façon <strong>progressive</strong>, en
            testant avec les codes données en exemple, et des codes ad-hoc
      pour chaque cas de figure.</p>
          
          <p>Le <strong>niveau de complétude</strong> de votre compilateur
            est donné comme suit:</p>
      <ol>
        <li>
          <p><code>write <em>constante</em></code>, est la seule
          instruction reconnue. Les problèmes de définition de
          variables sont traités.</p>
          <p>Codes de test:</p>
          <ul><li><code>undef.niklaus</code></li>
            <li><code>redef.niklaus</code></li>
            <li><code>basic.niklaus</code></li>
          </ul>
        </li>
        <li><p>Les variables sont traités: assignation, expression
            pouvant être une variable ou un
            entier. L'instruction <code>read</code> est
            traitée.</p>
          <p>Code de test:</p>
          <ul><li><code>var.niklaus</code></li>
          </ul>
        </li>
        <li><p>Les expressions de façon générique sont traitées
            (n'oubliez pas de mettre quelque chose
            dans <code>r6</code>...).</p>
          <p>Code de test:</p>
          <ul><li><code>calculations.niklaus</code></li>
          </ul>
        </li>
        <li><p>Les tests sont traités.</p>
          <p>Codes de test:</p>
          <ul><li><code>comp.niklaus</code></li>
            <li><code>test_if.niklaus</code></li>
          </ul>
          <p>Les tests sont assez redondant... Il est possible de
          factoriser beaucoup! Bonus si vous me faites quelque chose
          de compact.</p>
        </li>
        <li><p>Les boucles sont traitées (idem: bonus pour quelque chose de compact).</p>
          <p>Codes de test:</p>
          <ul><li><code>test_while_lt.niklaus</code></li>
            <li><code>pgcd.niklaus</code></li>
            <li><code>fibo.niklaus</code></li>
            <li><code>fact.niklaus</code> (que se passe-t-il en cas
            d'overflow ?</li></ul>
        </li>
      </ol>
    </li>
  </ol></li></ol>

  <h3>À rendre</h3>

  <p><strong>Attention:</strong> travail individuel.</p>

  <ul>
    <li>le fichier <tt>Niklaus.g</tt>, mis à jour.</li>
    <li>les fichiers pythons</li>
    <li>un rapport en PDF présentant
      <ul><li>vos choix d'implémentation</li>
        <li>ce qui a été fait</li>
        <li>les arbres de syntaxe de chaque programme proposé (une copie d'écran par exemple)</li>
        <li>le <em>niveau de complétude</em> de votre code (voir au
          dessus)</li>
        <li>les problèmes rencontrés et les solutions
          choisies</li>
      </ul>
  </ul>
  
  <h3>Livraison en deux temps</h3>
  
  <ul>
    <li>À la fin du BE : ce que vous avez fait.</li>
    <li>À la fin du mois : l'ensemble du travail demandé.</li>
  </ul>

  <h2 id="kit">3 - Configuration</h2>

  <h3>Contenu du kit</h3>

  <p>Le kit fourni est une archive ZIP qui contient :</p>
  <ul>
    <li><code>sujet_be.html</code> : ce fichier</li>
    <li><code>assembler.py</code> : code python transformant un code
    d'assemblage en un fichier <code>.mem</code> qui peut être charger
    par la machine de cours. </li>
    <li><code>Niklaus.g</code> : une ébauche de grammaire pour Niklaus</li>
    <li><code>ProgrammesNiklaus/*.niklaus</code> : un ensemble de
      programmes de tests écrits en Niklaus. Votre
      compilateur <strong>doit</strong> avoir le comportement indiqué
      en commentaires au début du fichier.</li>
    <li><code>miniARM_IO.circ</code> : le circuit du micro-processeur
    cible.</li>
    <li><code>test.arm</code> : un code d'assemblage de test</li>
    <li><code>lib.arm</code> : la librairie contenant les
      fonctions <code>readInt</code>, <code>printInt</code>,
      <code>readChr</code>, <code>printStr</code> présentées dans les
      transparents.</li>
  </ul>
  
  <h3>ANTLR</h3>

  <p>Décompressez le kit dans un répertoire de votre choix.</p>

  <p>Vous aurez besoin d'une installation Python et d'un
    compilateur Java. Afin de simplifier le travail, j'ai fait une
    image docker: <tt>bvaliron/antlr4</tt>. Pour l'utiliser, placez-vous
        avec la console dans le répertoire du kit et lancez la commande</p>
  <pre>
    docker run --name tdl -v .:/home -ti bvaliron/antlr4
  </pre>
  <p>Vous obtenez un prompt de l'intérieur du container. Le répertoire
  d'où vous êtes parti y est disponible (essayez avec la
  commande <tt>ls</tt> pour vérifier).</p>
  <p>
    Dans les dossiers <tt>calc1</tt>, <tt>calc2</tt>
    et <tt>calc3</tt> vous trouverez les grammaires d'expression
    présenté lors du tuto sur ANTLR. Vérifiez que vous pouvez en
    compiler:
  </p>
  <pre>
cd expr2
antlr4 -v 4.13.0 -Dlanguage=Python3 -visitor Calc.g4
python3 Main.py test.data
  </pre>
  <p>Vérifiez que <tt>python3 Main.py test.data</tt> calcule bien
    la bonne chose en changeant l'expression dans test.data.</p>
  <p>Vérifez aussi que rajouter un espace "casse" la
    reconnaissance.</p>

  <h3>Assembleur</h3>

  <p>Le kit contient un programme Python: <tt>assembler.py</tt>. Pour
    le tester, effectuez depuis la console (du container docker par
    exemple)</p>
    <pre>
python3 assembler.py test.arm
    </pre>
   <p>Cela devrait générer 2 fichiers dont un
   fichier <tt>test.mem</tt>, chargeable dans la machine logisim</p>
  
  <h3>Machine Logisim</h3>
  
  <p>La machine cible est la machine Logisim du cours de Frederic
    Boulanger, avec un bus en plus. Trois méthodes sont à votre
    disposition pour la faire fonctionner.</p>

  <p>Le cas le plus simple, si ça marche, est de le faire en
    local... Sinon, passez à la méthode 2 ou la plus légère, la
    méthode 3.</p>

  <p>Dans tous les cas, si vous bloquez à
  l'installation, <strong>passez à la méthode 3</strong>.</p>
  
  <h4>Méthode 1 : en local</h4>

  <ul>
    <li>
      dans la console (pas celle de l'image docker du début, car elle
      ne supporte pas les fenêtres graphiques), entrez dans le
      répertoire du Kit, et (sous linux) tappez <code>java -jar
      logisim-2.7.1.jar miniARM_IO.circ</code>.</li>
    <li>Logisim devrait ouvrir le micro-processeur avec tous ses
      composants. Il est possible qu'il indique avoir besoin de la
      librairie <code>ese1010.jar</code> et vous demande où elle se
      trouve: lui indiquer (elle est dans le répertoire du Kit).</li>
    <li>Chargez le fichier <tt>test.mem</tt> compilé juste avant dans
      la mémoire du processeur, comme ce qui est indiqué dans les
      transparents du cours.</li>
    <li>Lancez la machine: en principe, on doit vous demander 2
      entiers, et le programme doit afficher différents résultats
      d'opérations arithmétiques.</li>
  </ul>

  <h4>Méthode 2 : Logisim depuis mydocker</h4>

  <p>Il est sinon possible de ré-utiliser l'image mydocker proposée
    par Frederic Boulanger. Pour tout faire dans ce container, il vous
    faut importer le contenu du kit, et installer antlr4 avec les
    commandes</p>
  <pre>sudo apt update
sudo apt install pip
pip install antlr4-tools
pip install antlr4-python3-runtime==4.13.0
export PATH="~/.local/bin:$PATH"    
  </pre>
  <p>Vous avez ensuite accès à l'exécutable <tt>antlr4</tt> depuis ce
    container mydocker.</p>
  <p>Dans tous les cas, prenez soin d'ouvrir avec Logisim la
  machine <tt>miniARM_IO.circ</tt>.</p>
  
  <h4>Méthode 3 : un émulateur en ligne</h4>
  
  <p>Si vous voulez une version plus légère, je peux vous proposer une
    implémentation de la machine en
    javascript <a href="https://www.monoidal.net/miniARM/">ici</a>.
    Une doc est accessible depuis la page.</p>
  <p>
    <strong>Un petit bug</strong>: il faut éventuellement charger 2
    fois un fichier mem avant que celui-ci soit pris en compte. Par
    ailleurs, le chargement d'un fichier prend un peu de temps (~1
    seconde).</p>
    
  <h2 id="conseils">4 - Conseils de mise en oeuvre du compilateur</h2>
  
  <ul>
    <li><p>Mettez en place un parcours récursif ! En particulier,
        utilisez la même méthode que ce qui a été présenté dans les
        exemples avec <tt>Calc</tt>. Étendez la
        classe <tt>NiklausVisitor</tt> pour faire votre générateur de
        code assembleur.</p></li>
    <li><p>L'avant dernier transparent du cours vous donne la liste
        des choses à écrire dans votre fichier d'assemblage, dans
        l'ordre...</p></li>
    <li><p>N'oubliez pas de gérer la fin du programme avec quelque
          chose comme <code>@fin b fin</code>.</p></li>
  </ul>

  <h2 id="alt">5 - API de programmation pour l'assembleur</h2>

  <p>Pour implémenter votre compilateur, vous pouvez bien sûr tout
  faire à la main, en utilisant des chaines de caractères pour
  représenter les instructions. Mais le
  programme <tt>assembler.py</tt> n'est pas le même que celui de
  Frédéric Boulanger, et il contient une librairie de représentation
    des programmes ASM. Je vous invite à essayer:
<pre>from assembler import *

l1 = Label(prefix="blah")

c = ASM()

c.smw(12,label=l1)     # @blah smw 12
c.mov(Reg(0),2)        # mov r0, #2
c.mov(Reg(1),l1)       # mov r1, #blah
c.add(Reg(1),Reg(0),3) # add r1, r0, #3
c.ldr(Reg(3),Reg(1))   # ldr r3, [r1]
c.str(Reg(3),l1)       # str r3, #blah

c.showMem()
</pre>
  <p>Si cela vous inspire, vous pouvez explorer la documentation, avec dans l'ordre:
    <ul>
      <li><tt>help(ASM)</tt>. Un extrait:
<pre>class ASM(ASMcore)
 |  Encapsulate the writing of ASM programs.
 |  
 |  Once the ASM program is described, one can print it with 
 |  
 |   * show : the list of ASM instructions
 |   * showLst : the format "lst"
 |   * showMem : the format "mem", eatable by the logisim machine
 |  
 |  All of them accept the optional argument "filename" to send the stream
 |  to a file instead of stdout.
 |  
 |
 |  Methods defined here:
 |  
 |  load(self, filename)
 |      read and parse filename into an AST object, then concat it at the
 |      end of self.
 |  
 |  add(self, rx, ry, src, label=None)
 |  sub(self, rx, ry, src, label=None)
 |  cmp(self, ry, src, label=None)
 |
 |  mov(self, rx, src, label=None)
 |
 |  b(self, src, label=None)
 |  beq(self, src, label=None)
 |  blt(self, src, label=None)
 |  ldr(self, rx, src, label=None)
 |  str(self, rz, dest, label=None)
 |  
 |  pop(self, rx, label=None)
 |  push(self, rx, label=None)
 |
 |  rmw(self, v, label=None)
 |      Reserve v contiguous, empty words
 |
 |  smw(self, v, label=None)
 |      Reserve contiguous words to store value v. 
 |      
 |      - If v is an integer: should fit on 16 bits
 |      - If v is a string of size n: n+1 consecutive words are used, the last
 |        one being at 0.
 |      - If v is a length-n list of integers: n consecutive words are
 |        used. Each int should fit on 16 bits
 |  
 |  setFutureLabel(self, label)
 |      Store the label and will attach it to the next instruction to be
 |      added to self.
 |
 |  show(self, filename=None)
 |      Printout the instructions in ASM format.
 |  
 |  showLst(self, filename=None)
 |      Run "compile" and then nicely print the list of words in
 |      hexadecimal together with the corresponding instruction, and label
 |      correspondance.
 |  
 |  showMem(self, filename=None)
 |      Run "compile" and print the list of words in hexadecimal, ready to
 |      be ingested by logisim.
</pre>
        
      <li><tt>help(Label)</tt>. Un extrait:
<pre>class Label(Symb)
 |  Label(name=None, prefix='')
 |  
 |  Class to encapsulate label symbols.
 |  
 |  Label(name) generates a fresh name for you, or take the name (as a
 |  string) you provide. Two labels are equals if they have the same name:
 |  several invocation to Label("blah") are allowed and refer to the same
 |  label.
 |  
 |  Label(prefix="blah") generates a label with a unique name starting with
 |  blah. So two invocations to Label(prefix="blah") will give distinct
 |  labels.
 |  
 |  Label() can also be invoked without argument: a default prefix is then
 |  used.
</pre>
      <li><tt>help(Reg)</tt>. Un extrait:
        <pre>class Reg(builtins.object)
 |  Reg(n)
 |  
 |  class to encapsulate registers. 
 |  
 |  There are only 8 registers, numbered 0 to 7: the constructor takes the
 |  corresponding number.
</pre>
    </ul>
    
    
  
    


  
  <footer>
    <hr>
    <address>
      Benoit Valiron &lt;benoit.valiron@centralesupelec.fr&gt;
    </address>
  </footer>
</body>
</html>
